//------------------------------------------------------------------------------
// <auto-generated>
//     This code was auto-generated by com.unity.inputsystem:InputActionCodeGenerator
//     version 1.2.0
//     from Assets/Content/FPC/InputService/GameInput.inputactions
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.InputSystem;
using UnityEngine.InputSystem.Utilities;

public partial class @GameInput : IInputActionCollection2, IDisposable
{
    public InputActionAsset asset { get; }
    public @GameInput()
    {
        asset = InputActionAsset.FromJson(@"{
    ""name"": ""GameInput"",
    ""maps"": [
        {
            ""name"": ""FPC"",
            ""id"": ""8e789d1f-5edf-4c9b-b668-4004cda7cbc4"",
            ""actions"": [
                {
                    ""name"": ""Movement"",
                    ""type"": ""Value"",
                    ""id"": ""64737595-404d-4fcb-b780-e403ca56f648"",
                    ""expectedControlType"": ""Vector2"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": true
                },
                {
                    ""name"": ""View"",
                    ""type"": ""Value"",
                    ""id"": ""d72b6818-4132-48c4-b728-fc799e8ef65f"",
                    ""expectedControlType"": ""Vector2"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": true
                },
                {
                    ""name"": ""Jump"",
                    ""type"": ""Button"",
                    ""id"": ""c7b0d551-c7b6-45c5-a43f-7aef4b90935a"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""SitDown"",
                    ""type"": ""Button"",
                    ""id"": ""4dcacce2-33f0-4930-bd4e-73b7500af787"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""Interact"",
                    ""type"": ""Button"",
                    ""id"": ""2f62336a-ca99-4d88-b00c-b937e51cf6b0"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""Sprint"",
                    ""type"": ""Button"",
                    ""id"": ""7eaadeb5-e7fb-45a0-91d2-8e9573a259fd"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                }
            ],
            ""bindings"": [
                {
                    ""name"": ""WASD"",
                    ""id"": ""899e575b-ed86-47bb-9219-58b8568e0a29"",
                    ""path"": ""2DVector"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Movement"",
                    ""isComposite"": true,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": ""up"",
                    ""id"": ""fca454ab-50fa-456f-a88b-cadbd1a7ae7f"",
                    ""path"": ""<Keyboard>/w"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Movement"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""down"",
                    ""id"": ""82194028-cecd-43c1-867f-edba65159b0f"",
                    ""path"": ""<Keyboard>/s"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Movement"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""left"",
                    ""id"": ""bc19d79d-23a8-4796-9614-78d139679f1f"",
                    ""path"": ""<Keyboard>/a"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Movement"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""right"",
                    ""id"": ""0b024e3d-ff72-43e3-bab5-187252cc7c1a"",
                    ""path"": ""<Keyboard>/d"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Movement"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""Arrows"",
                    ""id"": ""4ce5ad10-0c56-422d-955c-6a587c5958af"",
                    ""path"": ""2DVector"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Movement"",
                    ""isComposite"": true,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": ""up"",
                    ""id"": ""f5dd7824-70b7-45ab-a5f9-82128cca76e1"",
                    ""path"": ""<Keyboard>/upArrow"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Movement"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""down"",
                    ""id"": ""511a9bf6-5947-4865-8c54-53b8f62df847"",
                    ""path"": ""<Keyboard>/downArrow"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Movement"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""left"",
                    ""id"": ""bb8d27eb-5a1a-491c-a53a-ebeaa9c4a96e"",
                    ""path"": ""<Keyboard>/leftArrow"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Movement"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""right"",
                    ""id"": ""80c97a89-1d4d-407e-bb6d-502ee4d3ebd3"",
                    ""path"": ""<Keyboard>/rightArrow"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Movement"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": """",
                    ""id"": ""65d64d40-6a42-441b-96df-6b7a62652537"",
                    ""path"": ""<Pointer>/delta"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""View"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""d111c53c-fed8-48e9-b896-d95c9cbf698c"",
                    ""path"": ""<Keyboard>/space"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Jump"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""f3616d46-6024-47c5-b4d0-ffc757100fc6"",
                    ""path"": ""<Keyboard>/c"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""SitDown"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""51b73221-57a2-49bb-a016-cec12f71558f"",
                    ""path"": ""<Keyboard>/f"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Interact"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""8e2a2676-44d5-4136-92a7-ede4bb0d1840"",
                    ""path"": ""<Keyboard>/leftShift"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Sprint"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                }
            ]
        }
    ],
    ""controlSchemes"": [
        {
            ""name"": ""PC"",
            ""bindingGroup"": ""PC"",
            ""devices"": []
        }
    ]
}");
        // FPC
        m_FPC = asset.FindActionMap("FPC", throwIfNotFound: true);
        m_FPC_Movement = m_FPC.FindAction("Movement", throwIfNotFound: true);
        m_FPC_View = m_FPC.FindAction("View", throwIfNotFound: true);
        m_FPC_Jump = m_FPC.FindAction("Jump", throwIfNotFound: true);
        m_FPC_SitDown = m_FPC.FindAction("SitDown", throwIfNotFound: true);
        m_FPC_Interact = m_FPC.FindAction("Interact", throwIfNotFound: true);
        m_FPC_Sprint = m_FPC.FindAction("Sprint", throwIfNotFound: true);
    }

    public void Dispose()
    {
        UnityEngine.Object.Destroy(asset);
    }

    public InputBinding? bindingMask
    {
        get => asset.bindingMask;
        set => asset.bindingMask = value;
    }

    public ReadOnlyArray<InputDevice>? devices
    {
        get => asset.devices;
        set => asset.devices = value;
    }

    public ReadOnlyArray<InputControlScheme> controlSchemes => asset.controlSchemes;

    public bool Contains(InputAction action)
    {
        return asset.Contains(action);
    }

    public IEnumerator<InputAction> GetEnumerator()
    {
        return asset.GetEnumerator();
    }

    IEnumerator IEnumerable.GetEnumerator()
    {
        return GetEnumerator();
    }

    public void Enable()
    {
        asset.Enable();
    }

    public void Disable()
    {
        asset.Disable();
    }
    public IEnumerable<InputBinding> bindings => asset.bindings;

    public InputAction FindAction(string actionNameOrId, bool throwIfNotFound = false)
    {
        return asset.FindAction(actionNameOrId, throwIfNotFound);
    }
    public int FindBinding(InputBinding bindingMask, out InputAction action)
    {
        return asset.FindBinding(bindingMask, out action);
    }

    // FPC
    private readonly InputActionMap m_FPC;
    private IFPCActions m_FPCActionsCallbackInterface;
    private readonly InputAction m_FPC_Movement;
    private readonly InputAction m_FPC_View;
    private readonly InputAction m_FPC_Jump;
    private readonly InputAction m_FPC_SitDown;
    private readonly InputAction m_FPC_Interact;
    private readonly InputAction m_FPC_Sprint;
    public struct FPCActions
    {
        private @GameInput m_Wrapper;
        public FPCActions(@GameInput wrapper) { m_Wrapper = wrapper; }
        public InputAction @Movement => m_Wrapper.m_FPC_Movement;
        public InputAction @View => m_Wrapper.m_FPC_View;
        public InputAction @Jump => m_Wrapper.m_FPC_Jump;
        public InputAction @SitDown => m_Wrapper.m_FPC_SitDown;
        public InputAction @Interact => m_Wrapper.m_FPC_Interact;
        public InputAction @Sprint => m_Wrapper.m_FPC_Sprint;
        public InputActionMap Get() { return m_Wrapper.m_FPC; }
        public void Enable() { Get().Enable(); }
        public void Disable() { Get().Disable(); }
        public bool enabled => Get().enabled;
        public static implicit operator InputActionMap(FPCActions set) { return set.Get(); }
        public void SetCallbacks(IFPCActions instance)
        {
            if (m_Wrapper.m_FPCActionsCallbackInterface != null)
            {
                @Movement.started -= m_Wrapper.m_FPCActionsCallbackInterface.OnMovement;
                @Movement.performed -= m_Wrapper.m_FPCActionsCallbackInterface.OnMovement;
                @Movement.canceled -= m_Wrapper.m_FPCActionsCallbackInterface.OnMovement;
                @View.started -= m_Wrapper.m_FPCActionsCallbackInterface.OnView;
                @View.performed -= m_Wrapper.m_FPCActionsCallbackInterface.OnView;
                @View.canceled -= m_Wrapper.m_FPCActionsCallbackInterface.OnView;
                @Jump.started -= m_Wrapper.m_FPCActionsCallbackInterface.OnJump;
                @Jump.performed -= m_Wrapper.m_FPCActionsCallbackInterface.OnJump;
                @Jump.canceled -= m_Wrapper.m_FPCActionsCallbackInterface.OnJump;
                @SitDown.started -= m_Wrapper.m_FPCActionsCallbackInterface.OnSitDown;
                @SitDown.performed -= m_Wrapper.m_FPCActionsCallbackInterface.OnSitDown;
                @SitDown.canceled -= m_Wrapper.m_FPCActionsCallbackInterface.OnSitDown;
                @Interact.started -= m_Wrapper.m_FPCActionsCallbackInterface.OnInteract;
                @Interact.performed -= m_Wrapper.m_FPCActionsCallbackInterface.OnInteract;
                @Interact.canceled -= m_Wrapper.m_FPCActionsCallbackInterface.OnInteract;
                @Sprint.started -= m_Wrapper.m_FPCActionsCallbackInterface.OnSprint;
                @Sprint.performed -= m_Wrapper.m_FPCActionsCallbackInterface.OnSprint;
                @Sprint.canceled -= m_Wrapper.m_FPCActionsCallbackInterface.OnSprint;
            }
            m_Wrapper.m_FPCActionsCallbackInterface = instance;
            if (instance != null)
            {
                @Movement.started += instance.OnMovement;
                @Movement.performed += instance.OnMovement;
                @Movement.canceled += instance.OnMovement;
                @View.started += instance.OnView;
                @View.performed += instance.OnView;
                @View.canceled += instance.OnView;
                @Jump.started += instance.OnJump;
                @Jump.performed += instance.OnJump;
                @Jump.canceled += instance.OnJump;
                @SitDown.started += instance.OnSitDown;
                @SitDown.performed += instance.OnSitDown;
                @SitDown.canceled += instance.OnSitDown;
                @Interact.started += instance.OnInteract;
                @Interact.performed += instance.OnInteract;
                @Interact.canceled += instance.OnInteract;
                @Sprint.started += instance.OnSprint;
                @Sprint.performed += instance.OnSprint;
                @Sprint.canceled += instance.OnSprint;
            }
        }
    }
    public FPCActions @FPC => new FPCActions(this);
    private int m_PCSchemeIndex = -1;
    public InputControlScheme PCScheme
    {
        get
        {
            if (m_PCSchemeIndex == -1) m_PCSchemeIndex = asset.FindControlSchemeIndex("PC");
            return asset.controlSchemes[m_PCSchemeIndex];
        }
    }
    public interface IFPCActions
    {
        void OnMovement(InputAction.CallbackContext context);
        void OnView(InputAction.CallbackContext context);
        void OnJump(InputAction.CallbackContext context);
        void OnSitDown(InputAction.CallbackContext context);
        void OnInteract(InputAction.CallbackContext context);
        void OnSprint(InputAction.CallbackContext context);
    }
}
